# factor labels
# change file names

filelist = list.files(path="./data/raw/CrisisLexT6_data_raw", pattern="\\.csv",
                 full.names=TRUE, ignore.case=TRUE)

for (f in filelist) {
  # f <- filelist[2]
  # read file
  table <- read.csv(f, header = TRUE, quote = "\"'", colClasses = "character", stringsAsFactors = FALSE)
  table <- table[!duplicated(table$tweet), ] # remove dublicates

  # factor labels
  table$label <- factor(table$label)
  levels(table$label) <- list(
    `0` = "off-topic",
    `1` = "on-topic"
  )

  # write ready file
  write.csv(
    table,
    file = gsub("(.*)-.*", "./data/ready/T6_\\1.csv", basename(f)),
    quote = c(1, 2),
    row.names = FALSE,
    fileEncoding = "UTF-8"
  )
  cat(sprintf("[%5s] %s\n", nrow(table), basename(f)))
}

rm(table, f, filelist)
