

### --- 2014_Arkansas_Tornado_en -----------------------------------------------
f <- "2014_Arkansas_Tornado_en"
f <- sprintf("./data/raw/AIDR2015Q2_data_raw/%s.csv", f)
table <- read.csv(f, header = TRUE, quote = "\"", colClasses = "character", stringsAsFactors = FALSE)
table <- table[!duplicated(table$tweet_id), ] # remove dublicates
table <- subset(table, select = c("tweet_id", "tweet_text"))
names(table) <- c("tweet.id", "tweet")
# remove apostrophe in `tweet.id`
table$tweet.id <- substring(table$tweet.id, 2, 19)
# broken encoding, remove non-ASCII characters
table$tweet <- iconv(table$tweet, from = "latin1", to = "ascii", sub=" ")
# factor labels
table$label <- 1 # all records are disaster-related
# dataset balance
topic.off <- nrow(table[table$label == 0, ])
topic.on  <- nrow(table[table$label == 1, ])
cat(sprintf("\n\n-- %s --", f))
cat(sprintf("\noff: %4d, on: %4d, balance: %4.1f%% (part of on-topic in total)",
  topic.off, topic.on, topic.on/(topic.off+topic.on)*100
))
# write ready file
write.csv(
  table,
  file = gsub("(.*)_en\\.csv", "./data/ready/AIDR2015Q2_\\1.csv", basename(f)),
  # file = sprintf("./data/ready/AIDR2015Q2_%s", basename(gsub("_en", "-en", f))),
  quote = c(1, 2),
  row.names = FALSE,
  fileEncoding = "UTF-8"
)
cat(sprintf("[%5s] %s\n", nrow(table), basename(f)))

### --- 2014_Iceland_Volcano_en ------------------------------------------------
f <- "2014_Iceland_Volcano_en"
f <- sprintf("./data/raw/AIDR2015Q2_data_raw/%s.csv", f)
table <- read.csv(f, header = TRUE, quote = "\"", colClasses = "character", stringsAsFactors = FALSE)
table <- table[!duplicated(table$tweet_id), ] # remove dublicates
table <- subset(table, select = c("tweet_id", "tweet_text", "label"))
names(table) <- c("tweet.id", "tweet", "label")
# remove apostrophe in `tweet.id`
table$tweet.id <- substring(table$tweet.id, 2, 19)
# broken encoding, remove non-ASCII characters
table$tweet <- iconv(table$tweet, from = "latin1", to = "ascii", sub=" ")
# factor labels
table$label <- factor( tolower(table$label) )
# for (x in levels(table$label)) cat(sprintf("\n\"%s\",", x))
levels(table$label) <- list(
  `0` = c("not informative", "not related to crisis"),
  `1` = c("informative", "non-government")
)
# table[is.na(table$label), ]
# dataset balance
topic.off <- nrow(table[table$label == 0, ])
topic.on  <- nrow(table[table$label == 1, ])
cat(sprintf("\n\n-- %s --", f))
cat(sprintf("\noff: %4d, on: %4d, balance: %4.1f%% (part of on-topic in total)",
  topic.off, topic.on, topic.on/(topic.off+topic.on)*100
))
# write ready file
write.csv(
  table,
  file = gsub("(.*)_en\\.csv", "./data/ready/AIDR2015Q2_\\1.csv", basename(f)),
  # file = sprintf("./data/ready/AIDR2015Q2_%s", basename(gsub("_en", "-en", f))),
  quote = c(1, 2),
  row.names = FALSE,
  fileEncoding = "UTF-8"
)
cat(sprintf("[%5s] %s\n", nrow(table), basename(f)))

### --- 2015_Nepal_Earthquake_en -----------------------------------------------
f <- "2015_Nepal_Earthquake_en"
f <- sprintf("./data/raw/AIDR2015Q2_data_raw/%s.csv", f)
table <- read.csv(f, header = TRUE, quote = "\"", colClasses = "character", stringsAsFactors = FALSE)
table <- table[!duplicated(table$tweet_id), ] # remove dublicates
table <- subset(table, select = c("tweet_id", "tweet_text", "label"))
names(table) <- c("tweet.id", "tweet", "label")
# remove apostrophe in `tweet.id`
table$tweet.id <- substring(table$tweet.id, 2, 19)
# broken encoding, remove non-ASCII characters
table$tweet <- iconv(table$tweet, from = "latin1", to = "ascii", sub=" ")
# factor labels
table$label <- factor( tolower(table$label) )
# for (x in levels(table$label)) cat(sprintf("\n\"%s\",", x))
levels(table$label) <- list(
  `0` = c("not related or irrelevant", "not relevant",
          "sympathy and emotional support"),
  `1` = c("animal management", "caution and advice", "displaced people",
          "infrastructure and utilities", "infrastructure damage",
          "injured or dead people", "missing, trapped, or found people",
          "money", "other relevant", "other relevant information",
          "personal updates", "response efforts", "shelter and supplies",
          "urgent needs", "volunteer or professional services")
)
# table[is.na(table$label), ]
# dataset balance
topic.off <- nrow(table[table$label == 0, ])
topic.on  <- nrow(table[table$label == 1, ])
cat(sprintf("\n\n-- %s --", f))
cat(sprintf("\noff: %4d, on: %4d, balance: %4.1f%% (part of on-topic in total)",
  topic.off, topic.on, topic.on/(topic.off+topic.on)*100
))
# write ready file
write.csv(
  table,
  file = gsub("(.*)_en\\.csv", "./data/ready/AIDR2015Q2_\\1.csv", basename(f)),
  # file = sprintf("./data/ready/AIDR2015Q2_%s", basename(gsub("_en", "-en", f))),
  quote = c(1, 2),
  row.names = FALSE,
  fileEncoding = "UTF-8"
)
cat(sprintf("[%5s] %s\n", nrow(table), basename(f)))

### --- Landslides_Worldwide_en ------------------------------------------------
f <- "Landslides_Worldwide_en"
f <- sprintf("./data/raw/AIDR2015Q2_data_raw/%s.csv", f)
table <- read.csv(f, header = TRUE, quote = "\"", colClasses = "character", stringsAsFactors = FALSE)
table <- table[!duplicated(table$tweet_id), ] # remove dublicates
table <- subset(table, tweet_language == "en", select = c("tweet_id", "tweet_text", "label"))
names(table) <- c("tweet.id", "tweet", "label")
# remove apostrophe in `tweet.id`
table$tweet.id <- substring(table$tweet.id, 2, 19)
# broken encoding, remove non-ASCII characters
table$tweet <- iconv(table$tweet, from = "latin1", to = "ascii", sub=" ")
# factor labels
table$label <- factor(table$label)
levels(table$label) <- list(
  `0` = c("Not physical landslide", "Traditional media"),
  `1` = c("Physical landslide")
)
# dataset balance
topic.off <- nrow(table[table$label == 0, ])
topic.on  <- nrow(table[table$label == 1, ])
cat(sprintf("\n\n-- %s --", f))
cat(sprintf("\noff: %4d, on: %4d, balance: %4.1f%% (part of on-topic in total)",
  topic.off, topic.on, topic.on/(topic.off+topic.on)*100
))
# write ready file
write.csv(
  table,
  file = gsub("(.*)_en\\.csv", "./data/ready/AIDR2015Q2_\\1.csv", basename(f)),
  # file = sprintf("./data/ready/AIDR2015Q2_%s", basename(gsub("_en", "-en", f))),
  quote = c(1, 2),
  row.names = FALSE,
  fileEncoding = "UTF-8"
)
cat(sprintf("[%5s] %s\n", nrow(table), basename(f)))


### ----------------------------------------------------------------------------
f <- "2014_California_Earthquake_en"
### ----------------------------------------------------------------------------
f <- "2014_Chile_Earthquake_en"
### ----------------------------------------------------------------------------
f <- "2014_Hurricane_Odile_Mexico_en"
### ----------------------------------------------------------------------------
f <- "2014_Malaysia_Airline_MH370_en"
### ----------------------------------------------------------------------------
f <- "2014_Middle_East_Respiratory_Syndrome_en"
### ----------------------------------------------------------------------------
f <- "2014_Typhoon_Hagupit_en"
### ----------------------------------------------------------------------------
f <- "2015_Cyclone_Pam_en"





### dataset summary

filelist = list.files(path="./data/ready", pattern="AIDR2015Q2_.*\\.csv",
                      full.names=TRUE, ignore.case=TRUE)
data <- do.call("rbind", lapply(filelist, function(x) {
  table <- read.csv(x, header = TRUE)
  table$file <- gsub("\\./data/ready/(.*)\\.csv", "\\1", x)
  return (table)
}))

# topic.off <- nrow(data[data$label == 0, ])
# topic.on  <- nrow(data[data$label == 1, ])
# cat(sprintf("\n\n-- AIDR2015Q2 --", x))
# cat(sprintf("\noff: %4d, on: %4d, balance: %4.1f%% (part of on-topic in total)",
#   topic.off, topic.on, topic.on/(topic.off+topic.on)*100
# ))

datasets <- gsub("\\./data/ready/(.*)\\.csv", "\\1", filelist)
for (x in datasets) {
  set <- data[data$file == x, ]
  topic.off <- nrow(set[set$label == 0, ])
  topic.on  <- nrow(set[set$label == 1, ])
  cat(sprintf("\n\n-- %s --", x))
  cat(sprintf("\noff: %4d, on: %4d (%4.1f%%)",
    topic.off, topic.on, topic.on/(topic.off+topic.on)*100
  ))
}


rm(data, set, table, datasets, f, filelist, topic.on, topic.off, x)
