library(tm)
library(RTextTools)
library(ROCR)
library(ggplot2)

### console
options(max.print = 100)

### load data ------------------------------------------------------------------
data.corpus <- readRDS("./saved/corpus.rds")
data <- data.frame(
  meta(data.corpus, "label", type="indexed"),
  meta(data.corpus, "file",  type="indexed")
)
data.dtm <- readRDS("./saved/dtmatrix.rds")

### SVM model ------------------------------------------------------------------
container <- create_container(
  matrix = data.dtm,
  labels = factor(data$label, levels = c(0,1), labels = c("off","on")),
  trainSize = 1:nrow(data),
  virgin = FALSE
)
# time: 30-40 min
model <- train_model(container, "SVM")
saveRDS(model, file = "./saved/model.final.rds")

rm(data, data.corpus, data.dtm, container, model)
