library(RPostgreSQL)

source('./11_classify.R')
source('./12_sql.R')

### PostgreSQL connect ---------------------------------------------------------
db.con <- dbConnect(PostgreSQL(),
  dbname = "twitter", host = "localhost", port = 5432,
  user = db.user, password = db.pass
)



### retrieve first data --------------------------------------------------------

sql.places.cnt <- 20
## maximum number of places when the index is still in use
# for (sql.places.cnt in 20:1) {
#   db.res <- dbGetQuery(db.con,
#     sprintf(paste('EXPLAIN (FORMAT TEXT)', sql.data, ' '),
#       disasters[disNum, 'sql'],
#       disasters[disNum, 'start_date'],
#       disasters[disNum, 'end_date'],
#       sql.places.cnt
#   ))
#   if (length(db.res[grepl('message', db.res$`QUERY PLAN`), ]) == 2) break
# }

# collect hashtags
hashtags <- dbGetQuery(db.con, sprintf(sql.data,
    disasters[disNum, 'sql'],
    disasters[disNum, 'start_date'],
    disasters[disNum, 'end_date'],
    sql.places.cnt
))
hashtags.original <- hashtags



### filter 1 :: low-frequent hashtags ------------------------------------------
hashtags <- hashtags[ hashtags$freq > 1, ]



### filter 2 :: foretime hashtags ----------------------------------------------
hashtags.filter.2 <- dbGetQuery(db.con,
  sprintf(sql.filter.1,
    disasters[disNum, 'sql'],
    disasters[disNum, 'start_date'],
    sql.places.cnt
))
hashtags.filter.2 <- hashtags.filter.2$hashtag
hashtags <- hashtags[ !(hashtags$tag %in% hashtags.filter.2), ]



### filter 4 :: ommon hashtags -------------------------------------------------
# it's placed before the filter #3 for the purpose of optimization
hashtags.filter.4 <- scan(file = "./13_filter_3.txt", what = "character", comment.char = "#")
hashtags <- hashtags[ !(hashtags$tag %in% hashtags.filter.4), ]



### filter 3 :: classification -------------------------------------------------
hashtags.filter.3 <- sapply(hashtags$tag, function(tag) {
  data <- dbGetQuery(db.con, sprintf(sql.filter.2,
    tag,
    disasters[disNum, 'start_date'],
    disasters[disNum, 'end_date']
  ))
  predict <- data.classify(data)
  predict <- subset(predict, is.na(predict) == FALSE)
  return( length(predict[predict == TRUE]) / length(predict) )
})
hashtags$rate <- hashtags.filter.3
hashtags <- hashtags[hashtags$rate > 0.5, ]



### finish ---------------------------------------------------------------------
db.res <- dbDisconnect(db.con)
rm(model, vocabulary, hashtags.original, hashtags.filter.2, hashtags.filter.3,
   hashtags.filter.4, sql.data, sql.filter.1, sql.filter.2, db.con, db.res,
   sql.places.cnt, data.classify, regex.url, regex.html, regex.user, removeRegEx)
